void scribe(String S) {fill(black); text(S,20,20); noFill();}
void scribe(String S, int i) {fill(black); text(S,20,20+i*20); noFill();}

void mousePressed() { if (mouse().isInWindow()) pickBlocks(); else ; } 
void mouseReleased() { }

void keyPressed() { 
  if (key==' ') showHelpText=!showHelpText ; 
  if  (48<int(key)) if (int(key)<58)  { n=int(key)-48; Clrs = new Colors(n); resetBlocks();}
  if (key=='g') G.y=0.2-G.y; 
  if (key=='X') {String S=" "+"-####.tif"; saveFrame(S);};   ;
  if (key=='?') printIt=true;  // toggle debug mode
  if (key=='r') {resetBlocks(); freeze=false; hi=-1; hj=-1;}
  };     

void showHelp() {
    fill(dblue); pushMatrix(); translate(20,20);
     text("Dynamic of blocks pulled by a spring by Jarek Rossignac",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("First click in the window to activate it ",0,0); translate(0,20);
     text("Press SPACE to show/hide this help text",0,0); translate(0,20);
     text("Click on the block to attach a string ",0,0); translate(0,20);
     text("pres 'g' to toggle gravity on/off ",0,0); translate(0,20);
     text("Press '1' through '9' to change the number of blocks",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("See http://www.myphysicslab.com/collision.html for explanations",0,0); translate(0,20);
     text("  ",0,0); translate(0,20);
     text("C=Center of mass. d='velocity. a=angle. a'=angular velocity. A=anchor point of spring. M=mouse.",0,0); translate(0,20);
     text("d=depth/2. w=width/2. d=density. m=4dhw=mass. I=m(ww+hh)/3=inertia. f=friction. s=spring constant. G=gravity.",0,0); translate(0,20);
     text("Update: ",0,0); translate(0,20);
     text("C  += t C'                // displace center of mass by velocity",0,0); translate(0,20);
     text("C' -= t f w h C'          // add deceleration due to friction (against the screen)",0,0); translate(0,20);
     text("C' += t G                 // add vertical gravity",0,0); translate(0,20);
     text("C' += (t s / m) A M       // add acceleration due to spring force sAM ",0,0); translate(0,20);
     text("a  += t a'                // add angular velocity to angle",0,0); translate(0,20);
     text("a' -= t f h w a'          // subtract rotational friction from angular velocity",0,0); translate(0,20);
     text("a' += t s R(OA)*AM / I    // add torque of spring using tangential component of AM. (* is dot product) ",0,0); translate(0,20);    
     text("  ",0,0); translate(0,20);
     text("Press 'X' top snap a picture (when running Processing, not in browser)",0,0); translate(0,20);
     text("'?' print debugging stuff (when running Processing, not in browser)   ",0,0); translate(0,20);
     popMatrix(); noFill();
   }
     
